#!/usr/bin/perl
#
#           RiSearch SQL
#
# web search engine, version 0.1
# (c) Sergej Tarasov, 2000-2002
#
# Homepage: http://risearch.org/
# email: risearch@risearch.org
# Last modified: 29.07.2002

use DBI;

sub create_tables {

print "Create tables...\n";
print "Documents... ";
$dbh->do("drop table if exists documents") || print $dbh->errstr;
$dbh->do("CREATE TABLE documents (
		document_id int unsigned NOT NULL auto_increment,
		file_size int unsigned DEFAULT '0' NOT NULL,
		filename varchar(255) binary DEFAULT '' NOT NULL,
		title varchar(255) binary DEFAULT '' NOT NULL,
		description varchar(255) binary DEFAULT '' NOT NULL,
		PRIMARY KEY (document_id),
		UNIQUE filename (filename)
		)") or print "Error: ".$dbh->errstr;
print "Done...\n";

die if $dbh->errstr;

print "Words... ";
$dbh->do("drop table if exists words");
$dbh->do("CREATE TABLE words (
		word_id int unsigned NOT NULL auto_increment,
		word varchar(30) DEFAULT '' NOT NULL,
		PRIMARY KEY (word_id),
		UNIQUE (word)
		)") or print "Error: ".$dbh->errstr;
print "Done...\n";

die if $dbh->errstr;

		
print "Word_link... ";
$dbh->do("drop table if exists word_link");
$dbh->do("create table word_link (
		word_id int unsigned DEFAULT '0' NOT NULL,
		document_id int unsigned DEFAULT '0' NOT NULL,
		KEY (word_id)
		)") or print "Error: ".$dbh->errstr;
print "Done...\n";

die if $dbh->errstr;


}

1
	
